]> arthur.barton.de Git - backup-script.git/blob - bin/backup-script
d28caafbc8264f5a0c89149853cd3299966c1b2c
[backup-script.git] / bin / backup-script
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=$(basename "$0")
14 PIDFILE="/var/run/$NAME.pid"
15
16 DRYRUN=0
17 VERBOSE=0
18
19 export LC_ALL=C
20
21 declare -i count_all=0
22 declare -i count_started=0
23 declare -i count_ok=0
24 declare -i count_ok_vanished=0
25
26 destinations=""
27
28 # Default settings, can be overwritten in backup-script.conf:
29 conf_d="/etc/backup-script.d"
30 pre_exec=""
31 post_exec=""
32 default_source_root="/"
33 default_target=""
34 default_user="root"
35 default_ssh_args_add=""
36 default_rsync_args_add=""
37 default_exclude_args_add=""
38 default_compress=1
39 default_ping=1
40 default_local=0
41 default_generations=0
42 default_job_pre_exec=""
43 default_job_post_exec=""
44
45 Usage() {
46         echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
47         echo
48         echo "  -p, --progress    Show progress, see rsync(1)."
49         echo "  -n, --dry-run     Test run only, don't copy any data."
50         echo
51         echo "When no <system> is given, all defined systems are used."
52         echo
53         exit 1
54 }
55
56 CleanUp() {
57         if [ -n "$post_exec" ]; then
58                 echo "Executing \"$post_exec\" ..."
59                 sh -c $post_exec
60                 if [ $? -ne 0 ]; then
61                         echo "Warning: post-exec command failed!"
62                 fi
63                 echo
64         fi
65         rm -f "$PIDFILE"
66 }
67
68 GotSignal() {
69         echo
70         echo "--> Got break signal, cleaning up & aborting ..."
71         echo
72         CleanUp
73         echo -n "Aborted: "; date
74         echo
75         sleep 3
76         exit 9
77 }
78
79 ExecJob() {
80         local what="$1"
81         local cmd="$2"
82
83         echo "Running job ${what}-exec command ..."
84         [ "$local" -eq 0 ] \
85                 && cmd="$ssh_cmd ${user}@${system} $cmd"
86         echo -n "Start date (${what}-exec): "; date
87         echo "$cmd"
88         if [ "$DRYRUN" -eq 0 ]; then
89                 $SHELL -c "$cmd"; local ret=$?
90         else
91                 echo " *** Trial run, not executing ${what}-exec command!"
92                 ret=0
93         fi
94         [ $ret -eq 0 ] \
95                 && echo "The ${what}-exec command completed with status 0, OK." \
96                 || echo "The ${what}-exec command completed with ERRORS, code $ret!"
97         return $ret
98 }
99
100 GetFS() {
101         local dir="$1"
102
103         while [ -n "$dir" ]; do
104                 findmnt -fn -o FSTYPE --raw "$dir" 2>/dev/null; local r=$?
105                 if [ $r -eq 0 ]; then
106                         return 0
107                 elif [ $r -eq 127 ]; then
108                         echo "UNKNOWN"
109                         return 1
110                 fi
111                 dir=$(dirname "$dir") || return 1
112         done
113 }
114
115 CreateSubvolume() {
116         local volume="$1"
117         local fs
118         local dir
119
120         dir=$(dirname "$volume")
121         fs=$(GetFS "$dir")
122         case "$fs" in
123           "btrfs")
124                 btrfs subvolume create "$volume"  >/dev/null || return 1
125                 ;;
126           "zfs")
127                 zfs create "$(echo "$volume" | cut -c2-)" || return 1
128                 ;;
129           *)
130                 echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
131                 return 9
132         esac
133         return 0
134 }
135
136 CloneSubvolume() {
137         local source="$1"
138         local volume="$2"
139         local snapshot="$3"
140         local dir
141         local fs
142         local link_name
143
144         dir=$(dirname "source")
145         fs=$(GetFS "$source")
146         case "$fs" in
147           "btrfs")
148                 btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
149                 ;;
150           "zfs")
151                 zfs snapshot "$snapshot" || return 1
152                 link_name="$(echo "$snapshot" | cut -d@ -f2-)"
153                 ln -s \
154                         "$volume/.zfs/snapshot/$link_name" \
155                         "$(dirname "$volume")/$link_name"
156                 ;;
157           *)
158                 echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
159                 return 9
160         esac
161         return 0
162 }
163
164 RenameSubvolume() {
165         local source="$1"
166         local target="$2"
167         local fs
168
169         fs=$(GetFS "$source")
170         case "$fs" in
171           "btrfs")
172                 mv "$source" "$target" || return 1
173                 ;;
174           "zfs")
175                 zfs rename \
176                   "$(echo "$source" | cut -c2-)" \
177                   "$(echo "$target" | cut -c2-)" \
178                         || return 1
179                 ;;
180           *)
181                 echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
182                 return 9
183         esac
184         return 0
185 }
186
187 DeleteSubvolume() {
188         local volume="$1"
189         local fs
190         local id
191         local snapshot
192
193         fs=$(GetFS "$volume")
194         case "$fs" in
195           "btrfs")
196                 btrfs subvolume delete "$volume" >/dev/null || return 1
197                 ;;
198           "zfs")
199                 id="$(basename "$volume")"
200                 if [ -h "$volume" ]; then
201                         snapshot="$(dirname "$volume")/current@$id"
202                 else
203                         snapshot="$volume"
204                 fi
205                 zfs destroy -r "$(echo "$snapshot" | cut -c2-)" >/dev/null || return 1
206                 [ -h "$volume" ] && rm "$volume"
207                 ;;
208           *)
209                 echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
210                 return 9
211         esac
212         return 0
213 }
214
215 Initialize_Last_SysTarget_Snapshot() {
216         sys_target="$1"
217         unset last
218         unset snapshot
219
220         fs=$(GetFS "$sys_target")
221         case "$fs" in
222           "btrfs")
223                 # Search directory of last generation, if any
224                 last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
225                 if [ -n "$last" ]; then
226                         if [ ! -d "$last" ]; then
227                                 echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
228                                 echo
229                                 return 1
230                         fi
231                 fi
232                 sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
233                 snapshot="$sys_target"
234                 ;;
235           "zfs")
236                 # On ZFS, the last generation is always named "current"
237                 [ -e "$sys_target/current" ] \
238                         && last="$sys_target/current" \
239                         || last=""
240                 snapshot="$(echo "$sys_target/current" | cut -c2-)@$(date +%Y%m%d-%H%M%S)"
241                 sys_target="$sys_target/current"
242                 ;;
243           *)
244                 echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
245                 return 1
246         esac
247         return 0
248 }
249
250 while [ $# -gt 0 ]; do
251         case "$1" in
252           "-n"|"--dry-run")
253                 DRYRUN=1; shift
254                 ;;
255           "-p"|"--progress")
256                 VERBOSE=1; shift
257                 ;;
258           "-"*)
259                 Usage
260                 ;;
261           *)
262                 break
263         esac
264 done
265
266 trap GotSignal SIGINT
267
268 echo -n "Started: "; date
269
270 for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
271         if [ -r "$conf" ]; then
272                 echo "Reading configuration: \"$conf\" ..."
273                 source "$conf"
274         fi
275 done
276 echo
277
278 if [ $# -ge 1 ]; then
279         for s in "$@"; do
280                 if [ ! -r "${conf_d}/$s" ]; then
281                         echo "$NAME: Can' read \"${conf_d}/$s\"!"
282                         exit 1
283                 fi
284                 sys="$sys ${conf_d}/$s"
285         done
286 else
287         sys="${conf_d}/"*
288 fi
289
290 # check and create PID file
291 if [ -e "$PIDFILE" ]; then
292         echo "Lockfile \"$PIDFILE\" already exists."
293         echo "Is an other instance still running?"
294         echo
295         echo -n "Aborted: "; date
296         echo
297         exit 3
298 fi
299 touch "$PIDFILE" 2>/dev/null
300 if [ $? -ne 0 ]; then
301         echo "Warning: can't create PID file \"$PIDFILE\"!"
302         echo
303 else
304         echo "$$" >>"$PIDFILE"
305 fi
306
307 if [ -n "$pre_exec" ]; then
308         echo "Executing \"$pre_exec\" ..."
309         sh -c $pre_exec
310         if [ $? -ne 0 ]; then
311                 echo "Error: pre-exec command failed!"; echo
312                 CleanUp
313                 echo "Aborting backup."; echo
314                 exit 2
315         fi
316         sleep 2
317         echo
318 fi
319
320 for f in $sys; do
321         [ -r "$f" -a -f "$f" ] || continue
322
323         fname=$(basename "$f")
324         case "$fname" in
325                 "backup-script.conf"|*.sh)
326                         continue
327                         ;;
328         esac
329
330         # Set global defaults
331         system="$fname"
332         user="$default_user"
333         source_root="$default_source_root"
334         target="$default_target"
335         ssh_args_add="$default_ssh_args_add"
336         rsync_args_add="$default_rsync_args_add"
337         exclude_args_add="$default_exclude_args_add"
338         compress="$default_compress"
339         ping="$default_ping"
340         local="$default_local"
341         generations="$default_generations"
342         job_pre_exec="$default_job_pre_exec"
343         job_post_exec="$default_job_post_exec"
344
345         # Compatibility with backup-pull(1) script: Save global values ...
346         pre_exec_saved="$pre_exec"
347         post_exec_saved="$post_exec"
348
349         # Compatibility with backup-pull(1) script: Set defaults
350         unset host
351         unset source
352         unset pre_exec
353         unset post_exec
354
355         # Read in system configuration file
356         source "$f"
357
358         # Compatibility with backup-pull(1) script: Fix up configuration
359         [ "$system" = "$fname" -a -n "$host" ] \
360                 && system="$host"
361         [ "$source_root" = "$default_source_root" -a -n "$source" ] \
362                 && source_root="$source"
363         [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
364                 && job_pre_exec="$pre_exec"
365         [ -z "$job_post_exec" -a -n "$post_exec" ] \
366                 && job_post_exec="$post_exec"
367
368         # Compatibility with backup-pull(1) script: Restore global values ...
369         pre_exec="$pre_exec_saved"
370         post_exec="$post_exec_saved"
371
372         # Validate configuration
373         [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
374
375         [ "$system" = "$fname" ] \
376                 && systxt="\"$system\"" \
377                 || systxt="\"$fname\" [\"$system\"]"
378         [ "$local" -eq 0 ] \
379                 && echo "Working on $systxt ..." \
380                 || echo "Working on $systxt (local system) ..."
381
382         count_all=$count_all+1
383
384         # Check target directory
385         if [ -z "$target" ]; then
386                 echo "No target directory specified for \"$system\"!? Skipped!"
387                 echo; continue
388         fi
389         if [ ! -d "$target" ]; then
390                 echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
391                 echo; continue
392         fi
393
394         sys_target="$target/$fname"
395         sys_root="$sys_target"
396         if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
397                 if [ $generations -gt 0 ]; then
398                         CreateSubvolume "$sys_target"
399                 else
400                         mkdir -p "$sys_target"
401                 fi
402                 if [ $? -ne 0 ]; then
403                         echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
404                         echo; continue
405                 fi
406         fi
407
408         if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
409                 # Check if system is alive
410                 ping -c 1 "$system" >/dev/null 2>&1
411                 if [ $? -ne 0 ]; then
412                         echo "Host \"$system\" seems not to be alive!? Skipped."
413                         echo; continue
414                 fi
415                 echo "OK, host \"$system\" seems to be alive."
416         fi
417
418         if [ $generations -gt 0 ]; then
419                 # Make sure no old backup is stored in system directory
420                 if [ -e "$sys_target/.stamp" ]; then
421                         # There seems to be a genearation-less backup in the
422                         # target directory!
423                         echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
424                         echo; continue
425                 fi
426
427                 Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
428
429                 if [ -n "$last" -a ! -e "$last/.stamp" ]; then
430                         # Old backup directory without "stamp file", continue
431                         echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
432                         RenameSubvolume "$last" "$sys_target"
433                         if [ $? -ne 0 ]; then
434                                 echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
435                                 echo; continue
436                         fi
437                 elif [ -n "$last" ]; then
438                         # Old backup directory found, create new snapshot
439                         echo "Found last snapshot in \"$last\"."
440                         if [ "$DRYRUN" -eq 0 ]; then
441                                 CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
442                                 if [ $r -ne 0 ]; then
443                                         echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
444                                         echo; continue
445                                 fi
446                                 echo "Created new snapshot in \"$snapshot\"."
447                         else
448                                 echo " *** Trial run, not creating new snapshot in \"$sys_target\"!"
449                         fi
450                 else
451                         # No old backup found, create new subvolume
452                         if [ "$DRYRUN" -eq 0 ]; then
453                                 CreateSubvolume "$sys_target"; r=$?
454                                 if [ $r -ne 0 ]; then
455                                         echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
456                                         echo; continue
457                                 fi
458                                 echo "Created new subvolume in \"$sys_target\"."
459                         else
460                                 echo " *** Trial run, not creating new subvolume \"$sys_target\"!"
461                         fi
462                 fi
463         fi
464
465         ssh_cmd="ssh"
466         [ -n "$ssh_args_add" ] && ssh_cmd="$ssh_cmd $ssh_args_add"
467
468         # execute job "pre-exec" command, if any
469         if [ -n "$job_pre_exec" ]; then
470                 ExecJob pre "$job_pre_exec" ; ret=$?
471                 if [ $ret -ne 0 ]; then
472                         [ $ret -ne 99 ] && count_started=$count_started+1
473                         echo "Pre-exec command failed, \"$system\" skipped!"
474                         echo; continue
475                 fi
476         fi
477
478         # prepare (remote) command ...
479         cmd="rsync --archive"
480         [ "$compress" -ne 0 ] && cmd="$cmd --compress"
481         [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
482         cmd="$cmd --delete --delete-excluded --sparse"
483         [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
484         if [ "$source_root" = "$default_source_root" ]; then
485                 cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
486                 cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
487                 cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
488                 cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
489         fi
490         [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
491         [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
492
493         [ "$local" -eq 0 ] \
494                 && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
495                 || cmd="$cmd $source_root $sys_target/"
496
497         echo "Backing up to \"$sys_target\" ..."
498         echo -n "Start date: "; date
499         echo "$cmd"
500         count_started=$count_started+1
501         ok=0
502
503         if [ "$DRYRUN" -eq 0 ]; then
504                 rm -f "$sys_target/.stamp"
505                 $SHELL -c "$cmd"; ret=$?
506                 echo "code=$ret" >"$sys_target/.stamp"
507         else
508                 echo " *** Trial run, not executing synchronization command!"
509                 ret=0
510         fi
511
512         if [ $ret -eq 20 ]; then
513                 echo "Backup of \"$system\" interrupted. Aborting ..."
514                 CleanUp
515                 exit 1
516         fi
517
518         echo -n "End date: "; date
519         if [ $ret -eq 0 -o $ret -eq 24 ]; then
520                 [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
521
522                 echo "System \"$system\" completed with status $ret, OK."
523                 [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
524                 ok=1
525         else
526                 echo "System \"$system\" completed with ERRORS, code $ret!"
527         fi
528
529         # execute job "post-exec" command, if any
530         if [ -n "$job_post_exec" ]; then
531                 ExecJob post "$job_post_exec"
532         fi
533
534         if [ $generations -gt 0 ]; then
535                 # Update "latest" symlink
536                 if [ "$DRYRUN" -eq 0 ]; then
537                         rm -f "$sys_root/latest"
538                         ln -s "$sys_target" "$sys_root/latest"
539                 fi
540                 # Clean up old generations
541                 declare -i gen_count=$generations+2
542                 to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
543                 if [ -n "$to_delete" -a $ok -eq 1 ]; then
544                         [ "$DRYRUN" -eq 0 ] \
545                                 && echo "Deleting old backup generations (keep $generations) ..." \
546                                 || echo " *** Trial run, not deleting old generations:"
547                         for delete in $to_delete; do
548                                 dir="$sys_root/$delete"
549                                 if [ ! -e "$dir/.stamp" ]; then
550                                         echo "Not deleting \"$dir\", not a backup directory!?"
551                                         continue
552                                 fi
553                                 last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
554                                  | cut -d':' -f2- | cut -d. -f1)
555                                 echo "Removing backup from" $last "..."
556                                 if [ "$DRYRUN" -eq 0 ]; then
557                                         DeleteSubvolume "$dir"
558                                         [ $? -eq 0 ] || \
559                                           echo "Failed to delete \"$dir\"!"
560                                 fi
561                         done
562                         echo -n "Clean up finished: "; date
563                 elif [ -n "$to_delete" ]; then
564                         echo "There have been errors, not cleaning up old generations!"
565                 else
566                         echo "Nothing to clean up."
567                 fi
568         fi
569
570         destinations="$destinations $target"
571         echo
572 done
573
574 sync
575
576 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
577 if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
578         df -h $paths
579         echo
580 fi
581
582 CleanUp
583
584 echo -n "Done: "; date
585 echo
586 [ $count_all -eq 1 ] && s="" || s="s"
587 echo " - $count_all job$s defined,"
588 [ $count_started -eq 1 ] && s="" || s="s"
589 echo " - $count_started job$s started,"
590 echo " - $count_ok done without errors."
591 echo
592
593 if [ $count_started -ne $count_ok ]; then
594         echo "----->  THERE HAVE BEEN ERRORS!  <-----"
595         echo
596 fi
597
598 # -eof-